#include "bloxorzz.h"
#include <iostream>
#include <string>
#include <cstdlib>
#include <ctime>
#include <cstdio>
using namespace std;
#include "rect.h"
#include "label.h"
#include <cmath>
#include "ezwin.h"
#include <cassert>
double pi=3.1415929;
float a=strtx,b=1,c=strty;
float x[8]={a-0.001,a+2,a+2.001,a,a+0.001,a+2.00001,a+2.01,a-0.00001}, y[8]={b+4,b+4.01,b,b+0.001,b+4.001,b+4.0001,b-0.001,b+0.0001}, z[8]={c+2,c+2.01,c+2.001,c+1.99,c,c+0.01,c-0.01,c+0.001};
int i, j,l1,l2;
int sortx[4]={0,3,4,7},sorty[4]={0,1,4,5},sortz[4]={4,5,6,7},base_points[4]={4,5,0,1};


float tmp[8];
void sortall();
void sort(float tp[8]);
Position P;
SimpleWindow MyWindow("Our Block", 30.0, 20.0,
                     Position(0.0, 0.0));


//Function to introduce delay [COPIED FROM www.cplusplus.com]
void wait ( float milliseconds )
{
    clock_t endwait;
    endwait = clock () + milliseconds * CLOCKS_PER_SEC/1000 ;
    while (clock() < endwait) {}
}

//Defining the rotation of coordinates about the axes
// x, y and z are the three coordinates of the block and p is the angle by which to rotate

void rotatex(float *x, float *y, float *z, int t){
    float k=t*pi/180;
    *z=*z*cos(k) + *y*sin(k);
    *y=*y*cos(k) - *z*sin(k); // Using the rotation formula about x axis
}

void rotatey(float *x, float *y, float *z, int t){
    float k=t*pi/180;
    *x=*x*cos(k) + *z*sin(k);
    *z=*z*cos(k) - *x*sin(k); // Using the rotation formula about y axis
}

void rotatez(float *x, float *y, float *z, int t){
    float k=t*pi/180;
    *y=*y*cos(k) + *x*sin(k);
    *x=*x*cos(k) - *y*sin(k); // Using the rotation formula about z axis
}

void draw_block(){
    //As we will be using pointers and changing the actual values of the variables,
    //so its required to introduce newer variables instead of the original coordinates
     float u[8], v[8], w[8];
     for(i=0; i<8; i++){
       u[i]=x[i];
       v[i]=y[i];
       w[i]=z[i]; }
    //Now we will rotate the axes about x and y by a small angle to give a 3D view of the block   
    for(i=0;i<8;i++){
       rotatex(&u[i],&v[i],&w[i],25);
       rotatey(&u[i],&v[i],&w[i],25);
    }
  
    //Plotting the lines
    for(i=0;i<3;i++){
       MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+1],v[i+1]),
                           Red,0.0);
    }
  
    MyWindow.RenderLine(Position(u[3],v[3]),Position(u[0],v[0]),
                       Red,0.0);
  
  
    for(i=4;i<7;i++){
       MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+1],v[i+1]),
                           Red,0.0);
    }
  
    MyWindow.RenderLine(Position(u[4],v[4]),Position(u[7],v[7]),
                       Red,0.0);
  
    for(i=0;i<4;i++){
       MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+4],v[i+4]),
                           Red,0.0);
    }
  
}

void erase_block(){
    //It will be required to imitate draw_block precisely
    float u[8], v[8], w[8];
     for(i=0; i<8; i++){
       u[i]=x[i];
       v[i]=y[i];
       w[i]=z[i]; }
    for(i=0;i<8;i++){
       rotatex(&u[i],&v[i],&w[i],25);
       rotatey(&u[i],&v[i],&w[i],25);
    }
  
    //Erasing the lines
    for(i=0;i<3;i++){
       MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+1],v[i+1]),
                           White,0.0);
    }
  
    MyWindow.RenderLine(Position(u[3],v[3]),Position(u[0],v[0]),
                       White,0.0);
  
  
    for(i=4;i<7;i++){
       MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+1],v[i+1]),
                           White,0.0);
    }
  
    MyWindow.RenderLine(Position(u[4],v[4]),Position(u[7],v[7]),
                       White,0.0);
  
  
    for(i=0;i<4;i++){
       MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+4],v[i+4]),
                           White,0.0);
    }
  
}


//Function to rotate the cube about any of its edges through any angle
//(x1, y1, z1) and (x2, y2, z3) are the vertices of the edge about which cube is to be rotated
//p is the angle
void turn_mech(float *x, float *y, float *z, float x1, float y1, float z1, float x2, float y2, float z2, int p){
    //Translating the coordinates to bring one of the vertex to origin
    x2=x2-x1;
    y2=y2-y1;
    z2=z2-z1;
    *x=*x-x1;
    *y=*y-y1;
    *z=*z-z1;
    float a=(*x*x2 + *y*y2 + *z*z2)/(x2*x2 + y2*y2 + z2*z2 + 0.0001) ;
    float ax=*x-a*x2 , ay=*y-a*y2, az=*z-a*z2; //ax, ay and az denotes the vector from (*x,*y,*z) to its perpendicular on the edge
    float bx=y2*az - z2*ay, by=z2*ax - x2*az, bz=x2*ay-y2*ax; // (bx, by, bz) denotes the direction in which the rotation is to be done
    float r=sqrt (bx*bx + by*by + bz*bz);
    bx=bx/(r+0.0001);
    by=by/(r+0.0001);
    bz=bz/(r+0.0001); //Converting b to a unit vector
    r=sqrt (ax*ax + ay*ay + az*az); //There is no use of the magnitude of vector b, so we can convert the same variable into the magnitude of vector a
    float k=p*pi/360;
    ax=ax - 2*ax*sin(k)*sin(k) + 2*bx*sin(k)*cos(k)*r;
    ay=ay - 2*ay*sin(k)*sin(k) + 2*by*sin(k)*cos(k)*r;           
    az=az - 2*az*sin(k)*sin(k) + 2*bz*sin(k)*cos(k)*r;
  
    //Coming back to original coordinates
    *x=ax+a*x2+x1;
    *y=ay+a*y2+y1;
    *z=az+a*z2+z1;
}
void turn(int a, int b, int angle){

    for(j=0; j<angle; j++){
       for(i=0; i<8; i++){
           if (i!=a && i!=b) {turn_mech(&x[i], &y[i], &z[i], x[a], y[a], z[a], x[b], y[b], z[b], 1);}
       }
       draw_block();
       wait(5);
        system("clear");
	makemaze(3,3);
    }
      
}

void go_down(){
    float ytemp[8];
    for (i=0; i<8; i++){
        ytemp[i]=y[i];
    float v=0.3;
    for(j=0; j<100; j++){
        for(i=0; i<8;i++){
            y[i]=y[i] + v*0.1;
                }
        v=1.05*v;
        draw_block();
        wait(5);
        system("clear");
	makemaze(3,3);
        }
    for (i=0; i<8; i++){
        y[i]=ytemp[i];   
    }

int blockmove(const Position &P){
    erase_block();

    if(P.GetXDistance()>16&&P.GetXDistance()<18&&P.GetYDistance()>12&&P.GetYDistance()<13.9) //UP
       turn(base_points[3],base_points[2],90);
    if(P.GetXDistance()>14&&P.GetXDistance()<15.9&&P.GetYDistance()>14.1&&P.GetYDistance()<16) //LEFT
       turn(base_points[2],base_points[0],90);
    if(P.GetXDistance()>16&&P.GetXDistance()<18&&P.GetYDistance()>14.1&&P.GetYDistance()<16) //DOWN
       turn(base_points[0],base_points[1],90);
    if(P.GetXDistance()>18.1&&P.GetXDistance()<20&&P.GetYDistance()>14.1&&P.GetYDistance()<16) //RIGHT
       turn(base_points[1],base_points[3],90);
    sortall();

  
    draw_block ();
  
    return 0;
}

int ApiMain(){
    MyWindow.Open();
     assert(MyWindow.GetStatus() == WindowOpen);
    //Now we will define the coordinates of the block to test the program, actual coordinates will come after the input from keyboard
   
    draw_block();
    MyWindow.RenderRectangle(Position(16,12), Position(18,13.9),
                            Yellow, true);
    MyWindow.RenderRectangle(Position(14,14.1), Position(15.9,16),
                            Yellow, true);   
    MyWindow.RenderRectangle(Position(16,14.1), Position(18,16),
                            Yellow, true);
    MyWindow.RenderRectangle(Position(18.1,14.1), Position(20,16),
                            Yellow, true);
    MyWindow.RenderText(Position(16,12), Position(18,13.9),
                          "UP", Red);
    MyWindow.RenderText(Position(14,14.1), Position(15.9,16),
                          "LEFT", Red);   
    MyWindow.RenderText(Position(16,14.1), Position(18,16),
                          "DOWN", Red);
    MyWindow.RenderText(Position(18.1,14.1), Position(20,16),
                          "RIGHT", Red);
    //go_down();
    int count=0;
    while(count<10000)
    {
       MyWindow.SetMouseClickCallback(blockmove);
       count++;
      
    }
    return 0;
}

void sort(float cr[8])
{
    float temp;
    float min;
    int pos,k;
  
    for(i=0;i<8;i++)
       tmp[i]=cr[i];
    for (k=0; k<8 ; k++){
       min = tmp[k]; pos =k;
       for (i=k+1; i<8; i++) {
           if(tmp[i]<min){ min=tmp[i]; pos=i;}
       }
       temp = tmp[k];
       tmp[k] = tmp[pos];   
       tmp[pos] = temp;
      
      
    }
  
}


void sortall()
{
    sort(y);
    int k=0;
    for(i=0;i<8;i++)
    {
       for(j=4;j<8;j++)
       {
           if(y[i]==tmp[j])
           {
               sorty[k]=i;
               k++;
              
           }
       }
    }
  
    sort(x);
    k=0;
    for(i=0;i<8;i++)
    {
       for(j=0;j<4;j++)
       {
           if(x[i]==tmp[j])
           {
               sortx[k]=i;
               k++;
              
           }
       }
    }
  
    sort(z);
    k=0;
    for(i=0;i<8;i++)
    {
       for(j=0;j<4;j++)
       {
           if(z[i]==tmp[j])
           {
               sortz[k]=i;
               k++;
              
           }
       }
    }
  
  
    for(i=0;i<4;i++)
    {
       for(j=0;j<4;j++)
       {
           for(k=0;k<4;k++)
           {
              
               if(sorty[i]==sortx[j]&&sortx[j]==sortz[k])
                  
                   base_points[0]=sorty[i];
              
           }
       }
    }
  
    for(i=0;i<4;i++)
    {
       for(j=0;j<4;j++)
       {
           if(sorty[i]==sortz[j]&&sorty[i]!=base_points[0])
           {
               base_points[1]=sorty[i];
              
           }
       }
    }
  
  
    for(i=0;i<4;i++)
    {
       for(j=0;j<4;j++)
       {
           if(sorty[i]==sortx[j]&&sorty[i]!=base_points[0])
           {
               base_points[2]=sorty[i];
              
           }
       }
    }
  
    for(i=0;i<4;i++)
    {
       if(sorty[i]!=base_points[0]&&sorty[i]!=base_points[1]&&sorty[i]!=base_points[2])
           base_points[3]=sorty[i];
    }
  
}

