Program for the motion of the block:
#include <iostream>
#include <string>
#include <cstdlib>
#include <ctime>
#include <cstdio>
using namespace std;
#include "rect.h"
#include "label.h"
#include <cmath>
#include "ezwin.h"
#include <cassert>
double pi=3.1415929;
SimpleWindow MyWindow("Our Block", 15.0, 15.0,
            Position(1.0, 1.0));
int i, j;

//Function to introduce delay [COPIED FROM www.cplusplus.com]
void wait ( float milliseconds )
{
clock_t endwait;
endwait = clock () + milliseconds * CLOCKS_PER_SEC/1000 ;
while (clock() < endwait) {}
}

//Defining the rotation of coordinates about the axes
// x, y and z are the three coordinates of the block and p is the angle by which to rotate

void rotatex(float *x, float *y, float *z, int t){
  float k=t*pi/180;
          *z=*z*cos(k) + *y*sin(k);
          *y=*y*cos(k) - *z*sin(k); // Using the rotation formula about x axis
                                                                 }

void rotatey(float *x, float *y, float *z, int t){
    float k=t*pi/180;
          *x=*x*cos(k) + *z*sin(k);
          *z=*z*cos(k) - *x*sin(k); // Using the rotation formula about y axis
                                                                   }

void rotatez(float *x, float *y, float *z, int t){
  float k=t*pi/180;
          *y=*y*cos(k) + *x*sin(k);
          *x=*x*cos(k) - *y*sin(k); // Using the rotation formula about z axis
                                                                   }

void draw_block(float x[8], float y[8], float z[8]){
          //As we will be using pointers and changing the actual values of the variables,
          //so its required to introduce newer variables instead of the original coordinates
       float u[8], v[8], w[8];
       for(i=0; i<8; i++){
                u[i]=x[i];
                v[i]=y[i];
                w[i]=z[i]; }
      //Now we will rotate the axes about x and y by a small angle to give a 3D view of the block   
      for(i=0;i<8;i++){
                   rotatex(&u[i],&v[i],&w[i],5);
                   rotatey(&u[i],&v[i],&w[i],5);
                                }
         
      //Plotting the lines
      for(i=0;i<3;i++){
                       MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+1],v[i+1]),
                                           Red,0.0);
                      }

      MyWindow.RenderLine(Position(u[3],v[3]),Position(u[0],v[0]),
                  Red,0.0);


      for(i=4;i<7;i++){
                        MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+1],v[i+1]),
                                           Red,0.0);
                      }

     MyWindow.RenderLine(Position(u[4],v[4]),Position(u[7],v[7]),
                  Red,0.0);

      for(i=0;i<4;i++){
                       MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+4],v[i+4]),
                                           Red,0.0);
                       }
     
       }

void erase_block(float x[8], float y[8], float z[8]){
          //It will be required to imitate draw_block precisely
                   float u[8], v[8], w[8];
       for(i=0; i<8; i++){
                u[i]=x[i];
                v[i]=y[i];
                w[i]=z[i]; }
      for(i=0;i<8;i++){
                   rotatex(&u[i],&v[i],&w[i],5);
                   rotatey(&u[i],&v[i],&w[i],5);
                                }

     //Erasing the lines
      for(i=0;i<3;i++){
                       MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+1],v[i+1]),
                                           White,0.0);
                      }

      MyWindow.RenderLine(Position(u[3],v[3]),Position(u[0],v[0]),
                  White,0.0);


      for(i=4;i<7;i++){
                        MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+1],v[i+1]),
                                           White,0.0);
                      }

     MyWindow.RenderLine(Position(u[4],v[4]),Position(u[7],v[7]),
                  White,0.0);


      for(i=0;i<4;i++){
                       MyWindow.RenderLine(Position(u[i],v[i]),Position(u[i+4],v[i+4]),
                                           White,0.0);
                       }

        }


//Function to rotate the cube about any of its edges through any angle
//(x1, y1, z1) and (x2, y2, z3) are the vertices of the edge about which cube is to be rotated
//p is the angle
void turn_mech(float *x, float *y, float *z, float x1, float y1, float z1, float x2, float y2, float z2, int p){
          //Translating the coordinates to bring one of the vertex to origin
          x2=x2-x1;
          y2=y2-y1;
          z2=z2-z1;
          *x=*x-x1;
          *y=*y-y1;
          *z=*z-z1;
          float a=(*x*x2 + *y*y2 + *z*z2)/(x2*x2 + y2*y2 + z2*z2);
          float ax=*x-a*x2 , ay=*y-a*y2, az=*z-a*z2; //ax, ay and az denotes the vector from (*x,*y,*z) to its perpendicular on the edge
          float bx=y2*az - z2*ay, by=z2*ax - x2*az, bz=x2*ay-y2*ax; // (bx, by, bz) denotes the direction in which the rotation is to be done
          float r=sqrt (bx*bx + by*by + bz*bz);
          bx=bx/r;
          by=by/r;
          bz=bz/r; //Converting b to a unit vector
          r=sqrt (ax*ax + ay*ay + az*az); //There is no use of the magnitude of vector b, so we can convert the same variable into the magnitude of vector a
          float k=p*pi/360;
          ax=ax - 2*ax*sin(k)*sin(k) + 2*bx*sin(k)*cos(k)*r;
          ay=ay - 2*ay*sin(k)*sin(k) + 2*by*sin(k)*cos(k)*r;           
          az=az - 2*az*sin(k)*sin(k) + 2*bz*sin(k)*cos(k)*r;
          
          //Coming back to original coordinates
         *x=ax+a*x2+x1;
         *y=ay+a*y2+y1;
         *z=az+a*z2+z1;
                                          }
void turn(float x[8], float y[8], float z[8], int a, int b){
           for(j=0; j<90; j++){
               for(i=0; i<8; i++){
                      if (i!=a && i!=b) {turn_mech(&x[i], &y[i], &z[i], x[a], y[a], z[a], x[b], y[b], z[b], 1);}
                                  }
                                        draw_block(x, y, z);
                                        wait(50); //This is an arbitrary time subject to change
                                        erase_block(x, y, z);                                         
                                  }                        
              }
                          
int ApiMain(){
        MyWindow.Open();
       assert(MyWindow.GetStatus() == WindowOpen);
        float x[8], y[8], z[8], p;
           //Here statements of input from keyboard will be scribbed
        //Now we will define the coordinates of the block to test the program, actual coordinates will come after the input from keyboard
       for(i=0; i<4; i++){
                    z[i]=6;}
       for(i=4; i<8; i++){
                    z[i]=3;}
      y[0]=9;
      y[1]=9;
      y[4]=9;
      y[5]=9;
      y[3]=3;
      y[2]=3;
      y[6]=3;
      y[7]=3;
      x[1]=6;
      x[2]=6;
      x[5]=6;
      x[6]=6;
      x[0]=3;
      x[3]=3;
      x[7]=3;
      x[4]=3;
           
                     turn(x, y, z, 0, 1);       

turn(x, y, z, 2, 1);

turn(x, y, z, 4, 5);

turn(x, y, z, 6, 7);
     return 0;
             }
